/////////////////////////////////////////////////////
//  elfBbv[^[pgJE^           //
//  2024/07/03  PIC18F1320  C18                    //
/////////////////////////////////////////////////////

#ifndef _GLOBAL_H
#define _GLOBAL_H

///// CPU Type
#include <p18f1320.h>

///// ^̒Zk
typedef unsigned char uchar;
typedef unsigned int uint;
typedef unsigned long ulong;

///// Delay
#include <delays.h>
#define CONFIG_MHZ 20

///// A/d
typedef union{
    int adw;
    char adb[2];
}ADDATA;
extern ADDATA addata;
extern void ad_init(void);
extern int ad_conv(void);

///// Lcd
#define     lcd_port    LATB
#define     lcd_rs      LATBbits.LATB4
#define     lcd_stb     LATBbits.LATB5

extern void lcd_init(void);
extern void lcd_clear(void);
extern void lcd_cmd(char);
extern void lcd_data(char);
extern void lcd_str(char *);
extern void lcd_str_rom(rom const char *);

///// interrupt
extern void timer0_init(void);
extern void timer1_init(void);
extern volatile uchar staflg;
extern volatile uint ovfcntc;
extern volatile uchar tmr0c;
#endif
