////////////////////////////////////////////////////
//  elfBbv[^[pgJE^  main.c  //
//  2024/07/03  PIC18F1320  C18                   //
////////////////////////////////////////////////////

#include "global.h"

void lcd_frq(uint hz){              //g\
    uchar n1, n2, n3, n4, n5;

    lcd_clear();
    if (hz == 30000){
        lcd_cmd(0x80);
        lcd_str_rom("Overflow");
        return;
    }
    n1 = hz / 10000;
    hz = hz % 10000;
    n2 = hz / 1000;
    hz = hz  % 1000;
    n3 = hz / 100;
    hz = hz % 100;
    n4 = hz / 10;
    n5 = hz % 10;
    lcd_cmd(0x80);
    if(n1) lcd_data(n1 + 0x30);
    else lcd_data(' ');
    if(n1 || n2) lcd_data(n2 + 0x30);
    else lcd_data(' ');
    lcd_data(n3 + 0x30);
    lcd_data('.');
    lcd_data(n4 + 0x30);
    lcd_data(n5 + 0x30);
    lcd_data('M');
    lcd_data('H');
    lcd_cmd(0xc0);
    lcd_data('z');
}

void main(void)
{
    ulong frq;
    ulong volt;

    Delay1KTCYx(CONFIG_MHZ * 10);   //40mS
    Delay1KTCYx(CONFIG_MHZ * 10);   //40mS
    Delay1KTCYx(CONFIG_MHZ * 10);   //40mS
    ad_init();                      //`cϊ
    TRISA = 0b11110001;
    TRISB = 0b11000000;
    lcd_init();                     //t\
    timer0_init();
    timer1_init();
    INTCONbits.PEIE = 1;            //ӊ荞݂
    INTCONbits.GIE = 1;             //S荞݂
    while(1){
        while(!staflg);             //C[v
        staflg = 0;
//        frq = 256L * 10L * (256L * (ulong)ovfcntc + (ulong)tmr0c);
//        frq = frq / 10000L + 1L;
        frq = 256L * (256L * (ulong)ovfcntc + (ulong)tmr0c);    //1/10
        frq = frq / 1000L + 1L;                         // *10
        if (frq > 30000) frq = 30000;
        lcd_frq((uint)frq);
        volt = 5000L * (ulong)ad_conv() * 4L / 1024L;
        lcd_cmd(0xc2);
        if(volt < 6000) lcd_str_rom("VB_LOW");
        else lcd_str_rom("     ");
    }
}
